Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginsView.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginsView.cs	(revision 3547)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginsView.cs	(revision 3547)
@@ -0,0 +1,236 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using System.ServiceModel;
+using ICSharpCode.SharpZipLib.Zip;
+using System.IO;
+using HeuristicLab.PluginInfrastructure.Manager;
+
+namespace HeuristicLab.PluginInfrastructure.Advanced {
+  internal partial class LocalPluginsView : InstallationManagerControl {
+    private const string CheckingPluginsMessage = "Checking for updated plugins...";
+    private const string NoUpdatesAvailableMessage = "No updates available.";
+    private BackgroundWorker removePluginsBackgroundWorker;
+    private BackgroundWorker updatePluginsBackgroundWorker;
+
+    private ListViewGroup enabledPluginsGroup;
+    private ListViewGroup disabledPluginsGroup;
+
+    private PluginManager pluginManager;
+    public PluginManager PluginManager {
+      get { return pluginManager; }
+      set {
+        pluginManager = value;
+        UpdateControl();
+      }
+    }
+
+    private InstallationManager installationManager;
+    public InstallationManager InstallationManager {
+      get { return installationManager; }
+      set { installationManager = value; }
+    }
+
+    public LocalPluginsView()
+      : base() {
+      InitializeComponent();
+      enabledPluginsGroup = localPluginsListView.Groups["activePluginsGroup"];
+      disabledPluginsGroup = localPluginsListView.Groups["disabledPluginsGroup"];
+
+      removePluginsBackgroundWorker = new BackgroundWorker();
+      removePluginsBackgroundWorker.DoWork += new DoWorkEventHandler(removePluginsBackgroundWorker_DoWork);
+      removePluginsBackgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(removePluginsBackgroundWorker_RunWorkerCompleted);
+      updatePluginsBackgroundWorker = new BackgroundWorker();
+      updatePluginsBackgroundWorker.DoWork += new DoWorkEventHandler(updatePluginsBackgroundWorker_DoWork);
+      updatePluginsBackgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(updatePluginsBackgroundWorker_RunWorkerCompleted);
+
+      UpdateControl();
+    }
+
+
+
+    #region event handlers for plugin removal background worker
+    void removePluginsBackgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
+      if (e.Error != null) {
+        StatusView.ShowError("File Deletion Error", "There was problem while deleting files." + Environment.NewLine + e.Error.Message);
+      }
+      UpdateControl();
+      StatusView.HideProgressIndicator();
+      StatusView.UnlockUI();
+    }
+
+    void removePluginsBackgroundWorker_DoWork(object sender, DoWorkEventArgs e) {
+      IEnumerable<IPluginDescription> pluginsToRemove = (IEnumerable<IPluginDescription>)e.Argument;
+      if (pluginsToRemove.Count() > 0) {
+        installationManager.Remove(pluginsToRemove);
+        pluginManager.DiscoverAndCheckPlugins();
+      }
+    }
+    #endregion
+
+    #region event handlers for update plugins backgroundworker
+    void updatePluginsBackgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
+      if (e.Error != null) {
+        StatusView.ShowError("Connection Error",
+          "There was an error while connecting to the server." + Environment.NewLine +
+           "Please check your connection settings and user credentials.");
+      } else if (e.Cancelled) {
+        StatusView.ShowMessage(NoUpdatesAvailableMessage);
+      }
+      StatusView.RemoveMessage(CheckingPluginsMessage);
+      StatusView.HideProgressIndicator();
+      StatusView.UnlockUI();
+    }
+
+    void updatePluginsBackgroundWorker_DoWork(object sender, DoWorkEventArgs e) {
+      IEnumerable<IPluginDescription> selectedPlugins = (IEnumerable<IPluginDescription>)e.Argument;
+      var remotePlugins = installationManager.GetRemotePluginList();
+      // if there is a local plugin with same name and same major and minor version then it's an update
+      var pluginsToUpdate = from remotePlugin in remotePlugins
+                            let matchingLocalPlugins = from installedPlugin in selectedPlugins
+                                                       where installedPlugin.Name == remotePlugin.Name
+                                                       where installedPlugin.Version.Major == remotePlugin.Version.Major
+                                                       where installedPlugin.Version.Minor == remotePlugin.Version.Minor
+                                                       where IsNewerThan(remotePlugin, installedPlugin)
+                                                       select installedPlugin
+                            where matchingLocalPlugins.Count() > 0
+                            select remotePlugin;
+      if (pluginsToUpdate.Count() > 0) {
+        installationManager.Update(pluginsToUpdate);
+        pluginManager.DiscoverAndCheckPlugins();
+        e.Cancel = false;
+      } else {
+        e.Cancel = true;
+      }
+    }
+
+    private bool IsNewerThan(IPluginDescription plugin1, IPluginDescription plugin2) {
+      // newer: build version is higher, or if build version is the same revision is higher
+      if (plugin1.Version.Build < plugin2.Version.Build) return false;
+      else if (plugin1.Version.Build > plugin2.Version.Build) return true;
+      else return plugin1.Version.Revision > plugin2.Version.Revision;
+    }
+    #endregion
+
+    private void UpdateControl() {
+      ClearPluginList();
+      if (pluginManager != null) {
+        localPluginsListView.SuppressItemCheckedEvents = true;
+        foreach (var plugin in pluginManager.Plugins) {
+          var item = CreateListViewItem(plugin);
+          if (plugin.PluginState == PluginState.Enabled) {
+            item.Group = enabledPluginsGroup;
+          } else if (plugin.PluginState == PluginState.Disabled) {
+            item.Group = disabledPluginsGroup;
+          }
+          localPluginsListView.Items.Add(item);
+        }
+        localPluginsListView.SuppressItemCheckedEvents = false;
+      }
+      removeButton.Enabled = localPluginsListView.CheckedItems.Count > 0;
+      updateSelectedButton.Enabled = localPluginsListView.CheckedItems.Count > 0;
+    }
+
+    private void ClearPluginList() {
+      List<ListViewItem> itemsToRemove = new List<ListViewItem>(localPluginsListView.Items.OfType<ListViewItem>());
+      itemsToRemove.ForEach(item => localPluginsListView.Items.Remove(item));
+    }
+
+    private ListViewItem CreateListViewItem(PluginDescription plugin) {
+      ListViewItem item = new ListViewItem(new string[] { plugin.Name, plugin.Version.ToString(), plugin.Description });
+      item.Tag = plugin;
+      return item;
+    }
+
+    private void pluginsListView_ItemChecked(object sender, ItemCheckedEventArgs e) {
+      // checked items are marked for removal
+      if (e.Item.Checked) {
+        List<ListViewItem> modifiedItems = new List<ListViewItem>();
+        foreach (ListViewItem item in localPluginsListView.SelectedItems) {
+          var plugin = (IPluginDescription)item.Tag;
+          modifiedItems.Add(item);
+          // also uncheck all dependent plugins
+          foreach (ListViewItem dependentItem in localPluginsListView.Items) {
+            var dependent = (IPluginDescription)dependentItem.Tag;
+            if (!dependentItem.Checked && (from dep in dependent.Dependencies
+                                           where dep.Name == plugin.Name
+                                           where dep.Version == plugin.Version
+                                           select dep).Any()) {
+              modifiedItems.Add(dependentItem);
+            }
+          }
+        }
+        localPluginsListView.CheckItems(modifiedItems);
+      } else {
+        List<ListViewItem> modifiedItems = new List<ListViewItem>();
+        foreach (ListViewItem item in localPluginsListView.SelectedItems) {
+          var plugin = (IPluginDescription)item.Tag;
+          modifiedItems.Add(item);
+        }
+        localPluginsListView.UncheckItems(modifiedItems);
+      }
+      OnItemsCheckedChanged(EventArgs.Empty);
+    }
+
+    private void localPluginsListView_ItemActivate(object sender, EventArgs e) {
+      if (localPluginsListView.SelectedItems.Count > 0) {
+        var plugin = (PluginDescription)localPluginsListView.SelectedItems[0].Tag;
+        PluginView pluginView = new PluginView(plugin);
+        pluginView.Show();
+      }
+    }
+
+    private void OnItemsCheckedChanged(EventArgs eventArgs) {
+      removeButton.Enabled = localPluginsListView.CheckedItems.Count > 0;
+      updateSelectedButton.Enabled = localPluginsListView.CheckedItems.Count > 0;
+    }
+
+    private void updateSelectedButton_Click(object sender, EventArgs e) {
+      StatusView.LockUI();
+      StatusView.ShowProgressIndicator();
+      StatusView.RemoveMessage(NoUpdatesAvailableMessage);
+      StatusView.ShowMessage(CheckingPluginsMessage);
+      var checkedPlugins = localPluginsListView.CheckedItems.OfType<ListViewItem>()
+        .Select(item => item.Tag)
+        .OfType<IPluginDescription>()
+        .ToList();
+      updatePluginsBackgroundWorker.RunWorkerAsync(checkedPlugins);
+    }
+
+    private void removeButton_Click(object sender, EventArgs e) {
+      StatusView.LockUI();
+      StatusView.ShowProgressIndicator();
+      var checkedPlugins = localPluginsListView.CheckedItems.OfType<ListViewItem>()
+        .Select(item => item.Tag)
+        .OfType<IPluginDescription>()
+        .ToList();
+      removePluginsBackgroundWorker.RunWorkerAsync(checkedPlugins);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginEditor.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginEditor.Designer.cs	(revision 3546)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginEditor.Designer.cs	(revision 3547)
@@ -45,6 +45,6 @@
     /// </summary>
     private void InitializeComponent() {
+      this.uploadButton = new System.Windows.Forms.Button();
       this.refreshButton = new System.Windows.Forms.Button();
-      this.uploadButton = new System.Windows.Forms.Button();
       this.listView = new HeuristicLab.PluginInfrastructure.Advanced.MultiSelectListView();
       this.pluginNameHeader = new System.Windows.Forms.ColumnHeader();
@@ -54,24 +54,30 @@
       this.SuspendLayout();
       // 
-      // refreshButton
-      // 
-      this.refreshButton.Location = new System.Drawing.Point(3, 3);
-      this.refreshButton.Name = "refreshButton";
-      this.refreshButton.Size = new System.Drawing.Size(75, 23);
-      this.refreshButton.TabIndex = 6;
-      this.refreshButton.Text = "Refresh";
-      this.refreshButton.UseVisualStyleBackColor = true;
-      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
-      // 
       // uploadButton
       // 
       this.uploadButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.uploadButton.Location = new System.Drawing.Point(3, 482);
+      this.uploadButton.Enabled = false;
+      this.uploadButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.VS2008ImageLibrary_CommonElements_Objects_Arrow_Up;
+      this.uploadButton.Location = new System.Drawing.Point(78, 477);
       this.uploadButton.Name = "uploadButton";
-      this.uploadButton.Size = new System.Drawing.Size(75, 23);
+      this.uploadButton.Size = new System.Drawing.Size(114, 31);
       this.uploadButton.TabIndex = 7;
-      this.uploadButton.Text = "Upload";
+      this.uploadButton.Text = "Upload Selected";
+      this.uploadButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
       this.uploadButton.UseVisualStyleBackColor = true;
       this.uploadButton.Click += new System.EventHandler(this.uploadButton_Click);
+      // 
+      // refreshButton
+      // 
+      this.refreshButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.refreshButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.VS2008ImageLibrary_Objects_Internet;
+      this.refreshButton.Location = new System.Drawing.Point(0, 477);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(72, 31);
+      this.refreshButton.TabIndex = 6;
+      this.refreshButton.Text = "Refresh";
+      this.refreshButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
       // 
       // listView
@@ -86,7 +92,7 @@
             this.serverVersionHeader,
             this.descriptionHeader});
-      this.listView.Location = new System.Drawing.Point(3, 32);
+      this.listView.Location = new System.Drawing.Point(0, 0);
       this.listView.Name = "listView";
-      this.listView.Size = new System.Drawing.Size(536, 444);
+      this.listView.Size = new System.Drawing.Size(539, 471);
       this.listView.SuppressItemCheckedEvents = false;
       this.listView.TabIndex = 8;
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginEditor.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginEditor.cs	(revision 3546)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginEditor.cs	(revision 3547)
@@ -39,4 +39,13 @@
     private BackgroundWorker updateServerPluginsWorker;
 
+    private PluginManager pluginManager;
+    public PluginManager PluginManager {
+      get { return pluginManager; }
+      set {
+        // if (value == null) throw new ArgumentNullException();
+        pluginManager = value;
+      }
+    }
+
     public PluginEditor() {
       InitializeComponent();
@@ -58,8 +67,12 @@
     #region refresh plugins from server backgroundworker
     void updateServerPluginsWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
-      if (!e.Cancelled && e.Result != null) {
+      if (e.Error != null) {
+        MessageBox.Show("There was an error while connecting to the server." + Environment.NewLine +
+                   "Please check your connection settings and user credentials.");
+        UpdateControlsDisconnectedState();
+      } else {
         // refresh local plugins
         localAndServerPlugins.Clear();
-        foreach (var plugin in ApplicationManager.Manager.Plugins) {
+        foreach (var plugin in pluginManager.Plugins) {
           localAndServerPlugins.Add(plugin, null);
         }
@@ -88,6 +101,4 @@
         listView.CheckBoxes = true;
         UpdateControlsConnectedState();
-      } else {
-        UpdateControlsDisconnectedState();
       }
       // make sure cursor is set correctly
@@ -96,17 +107,6 @@
 
     void updateServerPluginsWorker_DoWork(object sender, DoWorkEventArgs e) {
-      try {
-        var client = DeploymentService.UpdateClientFactory.CreateClient();
-        e.Result = client.GetPlugins();
-        e.Cancel = false;
-      }
-      catch (EndpointNotFoundException) {
-        e.Result = null;
-        e.Cancel = true;
-      }
-      catch (FaultException) {
-        e.Result = null;
-        e.Cancel = true;
-      }
+      var client = DeploymentService.UpdateClientFactory.CreateClient();
+      e.Result = client.GetPlugins();
     }
     #endregion
@@ -115,5 +115,7 @@
     void pluginUploadWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
       Cursor = Cursors.Default;
-      if (e.Cancelled) {
+      if (e.Error != null) {
+        MessageBox.Show("There was an error while connecting to the server." + Environment.NewLine +
+                   "Please check your connection settings and user credentials.");
         UpdateControlsDisconnectedState();
       } else {
@@ -125,19 +127,10 @@
 
     void pluginUploadWorker_DoWork(object sender, DoWorkEventArgs e) {
-      try {
-        var selectedPlugins = (IEnumerable<IPluginDescription>)e.Argument;
-        DeploymentService.AdminClient adminClient = DeploymentService.AdminClientFactory.CreateClient();
-
-        foreach (var plugin in IteratePlugins(selectedPlugins)) {
-          SetMainFormStatusBar("Uploading", plugin);
-          adminClient.DeployPlugin(MakePluginDescription(plugin), CreateZipPackage(plugin));
-        }
-        e.Cancel = false;
-      }
-      catch (EndpointNotFoundException) {
-        e.Cancel = true;
-      }
-      catch (FaultException) {
-        e.Cancel = true;
+      var selectedPlugins = (IEnumerable<IPluginDescription>)e.Argument;
+      DeploymentService.AdminClient adminClient = DeploymentService.AdminClientFactory.CreateClient();
+
+      foreach (var plugin in IteratePlugins(selectedPlugins)) {
+        SetMainFormStatusBar("Uploading", plugin);
+        adminClient.DeployPlugin(MakePluginDescription(plugin), CreateZipPackage(plugin));
       }
     }
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.Designer.cs	(revision 3546)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.Designer.cs	(revision 3547)
@@ -74,5 +74,5 @@
       // 
       this.nameLabel.AutoSize = true;
-      this.nameLabel.Location = new System.Drawing.Point(3, 6);
+      this.nameLabel.Location = new System.Drawing.Point(12, 6);
       this.nameLabel.Name = "nameLabel";
       this.nameLabel.Size = new System.Drawing.Size(38, 13);
@@ -84,8 +84,8 @@
       this.nameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.nameTextBox.Location = new System.Drawing.Point(74, 3);
+      this.nameTextBox.Location = new System.Drawing.Point(81, 3);
       this.nameTextBox.Name = "nameTextBox";
       this.nameTextBox.ReadOnly = true;
-      this.nameTextBox.Size = new System.Drawing.Size(284, 20);
+      this.nameTextBox.Size = new System.Drawing.Size(268, 20);
       this.nameTextBox.TabIndex = 1;
       // 
@@ -94,8 +94,8 @@
       this.versionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.versionTextBox.Location = new System.Drawing.Point(74, 29);
+      this.versionTextBox.Location = new System.Drawing.Point(81, 29);
       this.versionTextBox.Name = "versionTextBox";
       this.versionTextBox.ReadOnly = true;
-      this.versionTextBox.Size = new System.Drawing.Size(284, 20);
+      this.versionTextBox.Size = new System.Drawing.Size(268, 20);
       this.versionTextBox.TabIndex = 3;
       // 
@@ -103,5 +103,5 @@
       // 
       this.versionLabel.AutoSize = true;
-      this.versionLabel.Location = new System.Drawing.Point(3, 32);
+      this.versionLabel.Location = new System.Drawing.Point(12, 32);
       this.versionLabel.Name = "versionLabel";
       this.versionLabel.Size = new System.Drawing.Size(45, 13);
@@ -113,8 +113,8 @@
       this.contactTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.contactTextBox.Location = new System.Drawing.Point(74, 55);
+      this.contactTextBox.Location = new System.Drawing.Point(81, 55);
       this.contactTextBox.Name = "contactTextBox";
       this.contactTextBox.ReadOnly = true;
-      this.contactTextBox.Size = new System.Drawing.Size(284, 20);
+      this.contactTextBox.Size = new System.Drawing.Size(268, 20);
       this.contactTextBox.TabIndex = 5;
       // 
@@ -122,5 +122,5 @@
       // 
       this.contactInfoLabel.AutoSize = true;
-      this.contactInfoLabel.Location = new System.Drawing.Point(3, 58);
+      this.contactInfoLabel.Location = new System.Drawing.Point(12, 58);
       this.contactInfoLabel.Name = "contactInfoLabel";
       this.contactInfoLabel.Size = new System.Drawing.Size(47, 13);
@@ -131,5 +131,5 @@
       // 
       this.licenseButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.licenseButton.Location = new System.Drawing.Point(3, 586);
+      this.licenseButton.Location = new System.Drawing.Point(3, 575);
       this.licenseButton.Name = "licenseButton";
       this.licenseButton.Size = new System.Drawing.Size(103, 23);
@@ -145,7 +145,7 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.dependenciesGroupBox.Controls.Add(this.dependenciesListView);
-      this.dependenciesGroupBox.Location = new System.Drawing.Point(6, 408);
+      this.dependenciesGroupBox.Location = new System.Drawing.Point(12, 408);
       this.dependenciesGroupBox.Name = "dependenciesGroupBox";
-      this.dependenciesGroupBox.Size = new System.Drawing.Size(355, 172);
+      this.dependenciesGroupBox.Size = new System.Drawing.Size(337, 145);
       this.dependenciesGroupBox.TabIndex = 1;
       this.dependenciesGroupBox.TabStop = false;
@@ -160,5 +160,5 @@
       this.dependenciesListView.Location = new System.Drawing.Point(3, 16);
       this.dependenciesListView.Name = "dependenciesListView";
-      this.dependenciesListView.Size = new System.Drawing.Size(349, 153);
+      this.dependenciesListView.Size = new System.Drawing.Size(331, 126);
       this.dependenciesListView.SmallImageList = this.imageList;
       this.dependenciesListView.TabIndex = 0;
@@ -191,5 +191,5 @@
       this.filesListView.Location = new System.Drawing.Point(3, 16);
       this.filesListView.Name = "filesListView";
-      this.filesListView.Size = new System.Drawing.Size(346, 140);
+      this.filesListView.Size = new System.Drawing.Size(331, 140);
       this.filesListView.SmallImageList = this.imageList;
       this.filesListView.TabIndex = 0;
@@ -212,7 +212,7 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.filesGroupBox.Controls.Add(this.filesListView);
-      this.filesGroupBox.Location = new System.Drawing.Point(9, 243);
+      this.filesGroupBox.Location = new System.Drawing.Point(12, 243);
       this.filesGroupBox.Name = "filesGroupBox";
-      this.filesGroupBox.Size = new System.Drawing.Size(352, 159);
+      this.filesGroupBox.Size = new System.Drawing.Size(337, 159);
       this.filesGroupBox.TabIndex = 11;
       this.filesGroupBox.TabStop = false;
@@ -223,8 +223,8 @@
       this.stateTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.stateTextBox.Location = new System.Drawing.Point(74, 145);
+      this.stateTextBox.Location = new System.Drawing.Point(81, 145);
       this.stateTextBox.Name = "stateTextBox";
       this.stateTextBox.ReadOnly = true;
-      this.stateTextBox.Size = new System.Drawing.Size(284, 20);
+      this.stateTextBox.Size = new System.Drawing.Size(268, 20);
       this.stateTextBox.TabIndex = 13;
       // 
@@ -232,5 +232,5 @@
       // 
       this.stateLabel.AutoSize = true;
-      this.stateLabel.Location = new System.Drawing.Point(3, 148);
+      this.stateLabel.Location = new System.Drawing.Point(12, 148);
       this.stateLabel.Name = "stateLabel";
       this.stateLabel.Size = new System.Drawing.Size(35, 13);
@@ -241,5 +241,5 @@
       // 
       this.errorLabel.AutoSize = true;
-      this.errorLabel.Location = new System.Drawing.Point(3, 174);
+      this.errorLabel.Location = new System.Drawing.Point(12, 174);
       this.errorLabel.Name = "errorLabel";
       this.errorLabel.Size = new System.Drawing.Size(32, 13);
@@ -250,5 +250,5 @@
       // 
       this.descriptionLabel.AutoSize = true;
-      this.descriptionLabel.Location = new System.Drawing.Point(3, 84);
+      this.descriptionLabel.Location = new System.Drawing.Point(12, 84);
       this.descriptionLabel.Name = "descriptionLabel";
       this.descriptionLabel.Size = new System.Drawing.Size(63, 13);
@@ -260,8 +260,8 @@
       this.errorTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.errorTextBox.Location = new System.Drawing.Point(74, 171);
+      this.errorTextBox.Location = new System.Drawing.Point(81, 171);
       this.errorTextBox.Name = "errorTextBox";
       this.errorTextBox.ReadOnly = true;
-      this.errorTextBox.Size = new System.Drawing.Size(284, 66);
+      this.errorTextBox.Size = new System.Drawing.Size(268, 66);
       this.errorTextBox.TabIndex = 18;
       this.errorTextBox.Text = "";
@@ -271,8 +271,8 @@
       this.descriptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.descriptionTextBox.Location = new System.Drawing.Point(74, 81);
+      this.descriptionTextBox.Location = new System.Drawing.Point(81, 81);
       this.descriptionTextBox.Name = "descriptionTextBox";
       this.descriptionTextBox.ReadOnly = true;
-      this.descriptionTextBox.Size = new System.Drawing.Size(284, 58);
+      this.descriptionTextBox.Size = new System.Drawing.Size(268, 58);
       this.descriptionTextBox.TabIndex = 19;
       this.descriptionTextBox.Text = "";
@@ -282,5 +282,5 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.ClientSize = new System.Drawing.Size(345, 576);
+      this.ClientSize = new System.Drawing.Size(361, 565);
       this.Controls.Add(this.descriptionTextBox);
       this.Controls.Add(this.errorTextBox);
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.cs	(revision 3546)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.cs	(revision 3547)
@@ -32,5 +32,5 @@
 
 namespace HeuristicLab.PluginInfrastructure.Advanced {
-  internal partial class PluginView : UserControl {
+  internal partial class PluginView : Form {
     private const string IMAGE_KEY_ASSEMBLY = "Assembly";
     private const string IMAGE_KEY_FILE = "File";
@@ -49,5 +49,5 @@
 
       this.plugin = plugin;
-      this.Name = "Plugin Details: " + plugin.ToString();
+      this.Text = "Plugin Details: " + plugin.ToString();
       UpdateControls();
     }
